/*****************************************************************
 * Copyright (c) 2015 Texas Instruments and others
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Raymond Pang - Initial API and implementation
 *****************************************************************/
var gc = gc || {};
gc.databind = gc.databind || {};


(function() // closure for private static methods and data.
{
    var MqttTopicBind = function(name, viewInstance)
    {
    	gc.databind.VariableLookupBindValue.call(this);
		this.setStale(true);
		this.setName(name);
	  	this.mqttViewInstance = viewInstance;
    };
    
    MqttTopicBind.prototype = new gc.databind.VariableLookupBindValue();

    MqttTopicBind.prototype.onValueChanged = function(oldValue, newValue, progress)
    {
        this.sendValue( newValue , progress);
    };
    
 	MqttTopicBind.prototype.sendValue = function(value, progress) 
    {
        var jsonString = JSON.stringify(value);
        if (this.mqttViewInstance)
        {
        	var topic = this.getName();
        	this.mqttViewInstance.sendTopic( topic, jsonString);
        }
        else 
        {
            gc.console.log('Discarded tx mqtt data: ' + jsonString);
        }
    };

    gc.databind.MqttModel = function(name, viewInstance) 
	{
	  	gc.databind.AbstractStreamingDataModel.call(this, name);
	  	this.init();
	  	this.mqttViewInstance = viewInstance;
	};
	
	gc.databind.MqttModel.prototype = new gc.databind.AbstractStreamingDataModel('mqtt');
	
	gc.databind.MqttModel.prototype.createNewBind = function(name)
	{
		if (this.mqttViewInstance.isTopicName( name ) )
		{
			return new MqttTopicBind(name, this.mqttViewInstance);
		}
		else
		{
			return gc.databind.AbstractStreamingDataModel.prototype.createNewBind.call(this, name);
		}
	};
}());






